
libstm32f4.a_SOURCES := $(wildcard components/drv/src/*.c)
libstm32f4.a_SOURCES += $(wildcard components/drv/src/hwf4/*.c)

libstm32f4.a_OBJECTS := $(patsubst components/drv/src/%.c,\
	components/drv/build/%.o, $(libstm32f4.a_SOURCES))

$(eval $(call toolchain,components/drv/build/libstm32f4.a))

components/drv/build/%.o: components/drv/src/%.c
	$(call cmd,cc_o_c)

components/drv/build/libstm32f4.a: OBJECTS := $(libstm32f4.a_OBJECTS)
components/drv/build/libstm32f4.a: CFLAGS  += -Icomponents/system/include \
                                              -Icomponents/drv/include
components/drv/build/libstm32f4.a: components/system/build/libSystem.a
components/drv/build/libstm32f4.a: $(libstm32f4.a_OBJECTS)
components/drv/build/libstm32f4.a: | components/drv/build/hwf4
	$(call cmd,ar)

components/drv/build:
	$(call cmd,mkdir)
components/drv/build/hwf4: | components/drv/build
	$(call cmd,mkdir)

clean::
	$(call cmd,rm,components/drv/build)
