
# COMPILER CONFIG

BASE_CFLAGS := -g -Wall -mlittle-endian -mcpu=cortex-m4 -mthumb \
               -mfloat-abi=hard -mfpu=fpv4-sp-d16 \
               -ffunction-sections -fdata-sections

CFLAGS   += $(BASE_CFLAGS) -std=gnu99
CXXFLAGS += $(BASE_CFLAGS) -fno-exceptions -fno-rtti

LDSCRIPT += components/system/support/stm32_flash.ld
LDFLAGS  += -mlittle-endian -mcpu=cortex-m4 -mthumb -mfloat-abi=hard \
            -mfpu=fpv4-sp-d16 -Wl,--script=$(LDSCRIPT) \
            -Wl,--gc-sections

# BOARD CONFIG

BOARD_FREQ := 8000000

CFLAGS += -DHSE_VALUE=$(BOARD_FREQ)
