
FREERTOS_INCLUDES := -I$(FREERTOS_PREFIX)/FreeRTOS/Source/include \
                     -I$(FREERTOS_PREFIX)/FreeRTOS/Source/portable/GCC/ARM_CM4F

FREERTOS_SOURCES := $(addprefix $(FREERTOS_PREFIX)/FreeRTOS/Source/,\
	list.c                       \
	queue.c                      \
	tasks.c                      \
	portable/GCC/ARM_CM4F/port.c \
	portable/MemMang/heap_3.c    \
)

FREERTOS_OBJECTS := $(patsubst $(FREERTOS_PREFIX)/FreeRTOS/Source/%.c,\
	components/system/build/%.o,$(FREERTOS_SOURCES))

$(FREERTOS_OBJECTS): components/system/build/%.o: \
	$(FREERTOS_PREFIX)/FreeRTOS/Source/%.c
	$(call cmd,cc_o_c)

SYSTEM_SOURCES := $(wildcard components/system/src/*.c)

SYSTEM_OBJECTS := $(patsubst components/system/src/%.c,\
	components/system/build/%.o,$(SYSTEM_SOURCES))

$(SYSTEM_OBJECTS): components/system/build/%.o: components/system/src/%.c
	$(call cmd,cc_o_c)

components/system/build/startup_stm32f40xx.o: \
	components/system/src/startup_stm32f40xx.s
	$(call cmd,cc_o_s)

libSystem.a_OBJECTS := $(SYSTEM_OBJECTS) $(FREERTOS_OBJECTS) \
	components/system/build/startup_stm32f40xx.o

components/system/build/libSystem.a: OBJECTS := $(libSystem.a_OBJECTS)
components/system/build/libSystem.a: CFLAGS  += -I$(FREERTOS_INCLUDES)
components/system/build/libSystem.a: $(libSystem.a_OBJECTS)
components/system/build/libSystem.a: \
	| components/system/build/portable/GCC/ARM_CM4F \
	  components/system/build/portable/MemMang
	$(call cmd,ar)

components/system/build/portable/GCC/ARM_CM4F: \
	| components/system/build/portable/GCC
	$(call cmd,mkdir)

components/system/build/portable/GCC components/system/build/portable/MemMang: \
	| components/system/build/portable
	$(call cmd,mkdir)

components/system/build/portable: | components/system/build
	$(call cmd,mkdir)

components/system/build:
	$(call cmd,mkdir)

clean::
	$(call cmd,rm,components/system/build)
