
upcn_SOURCES := $(filter-out components/upcn/src/main.c, \
	$(wildcard components/upcn/src/*.c))

upcn_OBJECTS := $(patsubst components/upcn/src/%.c,\
	components/test/build/upcn/%.o, $(upcn_SOURCES))

testupcn_SOURCES := $(wildcard components/test/src/*.c)

testupcn_OBJECTS := $(patsubst components/test/src/%.c,\
	components/test/build/%.o, $(testupcn_SOURCES))

testupcn_LIBS := components/drv/build/libstm32f4.a \
                 components/system/build/libSystem.a \
                 components/test/unity/build/libunity.a \

$(eval $(call toolchain,components/test/build/testupcn))

components/test/build/upcn/%.o: components/upcn/src/%.c
	$(call cmd,cc_o_c)
components/test/build/%.o: components/test/src/%.c
	$(call cmd,cc_o_c)

components/test/build/testupcn: OBJECTS := $(testupcn_OBJECTS) $(upcn_OBJECTS)
components/test/build/testupcn: LIBS    := $(testupcn_LIBS)
components/test/build/testupcn: CFLAGS  += -DUPCN_TEST_BUILD                \
                                           -Icomponents/test/include        \
                                           -Icomponents/test/unity/include  \
                                           -Icomponents/upcn/include        \
                                           -Icomponents/upcn/include/fs     \
                                           -Icomponents/drv/include         \
                                           -Icomponents/system/include      \
                                           $(FREERTOS_INCLUDES)
components/test/build/testupcn: LDFLAGS += -lm
components/test/build/testupcn: $(testupcn_LIBS)
components/test/build/testupcn: $(testupcn_OBJECTS) $(upcn_OBJECTS)
components/test/build/testupcn: | components/test/build/upcn
	$(call cmd,link)

components/test/build/testupcn.bin: components/test/build/testupcn
	$(call cmd,bin)

components/test/build:
	$(call cmd,mkdir)

components/test/build/upcn: | components/test/build
	$(call cmd,mkdir)

test: components/test/build/testupcn     \
      components/test/build/testupcn.bin

clean::
	$(call cmd,rm,components/test/build)

tclean::
	$(call cmd,rm,components/test/build)

include components/test/unity/build.mk
