
upcn_SOURCES := $(wildcard components/upcn/src/*.c)

upcn_OBJECTS := $(patsubst components/upcn/src/%.c,components/upcn/build/%.o, \
	$(upcn_SOURCES))

upcn_LIBS := components/drv/build/libstm32f4.a \
             components/system/build/libSystem.a \

$(eval $(call toolchain,components/upcn/build/upcn))

components/upcn/build/%.o: components/upcn/src/%.c
	$(call cmd,cc_o_c)

components/upcn/build/upcn: OBJECTS := $(upcn_OBJECTS)
components/upcn/build/upcn: LIBS    := $(upcn_LIBS)
components/upcn/build/upcn: CFLAGS  += -Icomponents/upcn/include     \
                                       -Icomponents/upcn/include/fs  \
                                       -Icomponents/drv/include      \
                                       -Icomponents/system/include   \
                                       $(FREERTOS_INCLUDES)
components/upcn/build/upcn: LDFLAGS += -lm
components/upcn/build/upcn: $(upcn_LIBS)
components/upcn/build/upcn: $(upcn_OBJECTS)
components/upcn/build/upcn: | components/upcn/build
	$(call cmd,link)

components/upcn/build/upcn.bin: components/upcn/build/upcn
	$(call cmd,bin)

components/upcn/build:
	$(call cmd,mkdir)

upcn: components/upcn/build/upcn.bin

clean::
	$(call cmd,rm,components/upcn/build)

uclean::
	$(call cmd,rm,components/upcn/build)
