#ifndef BUNDLEPROCESSOR_H_INCLUDED
#define BUNDLEPROCESSOR_H_INCLUDED

#include <FreeRTOS.h>
#include <queue.h>
#include <semphr.h>

#include <bundle.h>

enum bundle_processor_signal_type {
	BP_SIGNAL_BUNDLE_INCOMING,
	BP_SIGNAL_BUNDLE_ROUTED,
	BP_SIGNAL_FORWARDING_CONTRAINDICATED,
	BP_SIGNAL_BUNDLE_EXPIRED,
	BP_SIGNAL_RESCHEDULE_BUNDLE,
	BP_SIGNAL_TRANSMISSION_SUCCESS,
	BP_SIGNAL_TRANSMISSION_FAILURE
};

struct bundle_processor_signal {
	enum bundle_processor_signal_type type;
	enum bundle_status_report_reason reason;
	bundleid_t bundle;
};

struct bundle_processor_task_parameters {
	QueueHandle_t router_signaling_queue;
	QueueHandle_t signaling_queue;
};

void bundle_processor_inform(
	QueueHandle_t signaling_queue, bundleid_t bundle,
	enum bundle_processor_signal_type type,
	enum bundle_status_report_reason reason);
void bundle_processor_task(void *param);

#endif /* BUNDLEPROCESSOR_H_INCLUDED */
