#ifndef GROUNDSTATIONTASK_H_INCLUDED
#define GROUNDSTATIONTASK_H_INCLUDED

#include <FreeRTOS.h>
#include <queue.h>
#include <task.h>

#include <upcn.h>
#include <bundle.h>
#include <groundStation.h>

enum ground_station_task_command_type {
	GS_COMMAND_UNDEFINED, /* 0x00 */
	GS_COMMAND_BUNDLES,   /* 0x01 */
	GS_COMMAND_FINALIZE   /* 0x02 */
};

struct ground_station_task_command {
	enum ground_station_task_command_type type;
	struct routed_bundle_list *bundles;
	struct contact *contact;
};

struct ground_station_task_creation_result {
	TaskHandle_t task_handle;
	QueueHandle_t queue_handle;
	enum upcn_result result;
};

struct ground_station_task_creation_result ground_station_task_create(
	QueueHandle_t router_signaling_queue);
void ground_station_task_delete(QueueHandle_t queue);

#endif /* GROUNDSTATIONTASK_H_INCLUDED */
