#ifndef COMM_H_INCLUDED
#define COMM_H_INCLUDED

#include <stddef.h>
#include <stdint.h>

enum comm_type {
	COMM_TYPE_MESSAGE = 0x01,
	COMM_TYPE_BUNDLE = 0x02,
	COMM_TYPE_BEACON = 0x03,
	COMM_TYPE_ECHO = 0x04,
	COMM_TYPE_GS_INFO = 0x05,
	COMM_TYPE_PERF_DATA = 0x06,
	COMM_TYPE_RRND_STATUS = 0x07,
	COMM_TYPE_GENERIC_RESULT = 0x08,
	COMM_TYPE_UNDEFINED = 0xFF
};

uint8_t comm_init(void);
uint8_t comm_read(void);

void comm_begin_packet(const size_t length, const enum comm_type type);
void comm_end_packet(void);
void comm_send(const void *data, const size_t length);
void comm_send_packet(
	const void *data, const size_t length, const enum comm_type type);
void comm_write_raw(const void *data, const size_t length);
void comm_write(const char *string);
uint8_t comm_output_waiting(void);

#endif /* COMM_H_INCLUDED */
