#ifndef INPUTPARSER_H_INCLUDED
#define INPUTPARSER_H_INCLUDED

#include <stdint.h>

#include <parser.h>

enum input_type {
	INPUT_TYPE_UNDEFINED           = 0x00,
	INPUT_TYPE_ROUTER_COMMAND_DATA = 0x01,
	INPUT_TYPE_BUNDLE_DATA         = 0x02,
	INPUT_TYPE_BEACON_DATA         = 0x03,
	/* Some basic commands handles in inputParser */
	INPUT_TYPE_DBG_QUERY           = 0x04,
	INPUT_TYPE_RESET_TIME          = 0x05,
	INPUT_TYPE_SET_TIME            = 0x06,
	INPUT_TYPE_RESET_STATS         = 0x07,
	INPUT_TYPE_CLEAR_TRACES        = 0x08,
	INPUT_TYPE_STORE_TRACE         = 0x09,
	INPUT_TYPE_ECHO                = 0x0A,
	INPUT_TYPE_RESET               = 0x0B,
	INPUT_TYPE_GET_GS              = 0x0C,
	INPUT_TYPE_SET_SATPOS_TLE      = 0x0D,
	INPUT_TYPE_RRND_INFER_CONTACT  = 0x0E,
	INPUT_TYPE_RESET_ROUTING_DB    = 0x0F,
	INPUT_TYPE_MAX                 = 0x0F
};

enum input_parser_stage {
	INPUT_EXPECT_DATA_ESCAPE_DELIMITER,
	INPUT_EXPECT_DATA_BEGIN_MARKER,
	INPUT_EXPECT_TYPE,
	INPUT_EXPECT_TYPE_DELIMITER,
	INPUT_EXPECT_TIME,
	INPUT_EXPECT_DATA_END_MARKER,
	INPUT_EXPECT_DATA,
	INPUT_EXPECT_STRING_LENGTH,
	INPUT_EXPECT_STRING
};

struct input_parser {
	struct parser *basedata;
	enum input_parser_stage stage;
	enum input_type type;
	char *string;
	uint32_t intdata;
	uint16_t intdata_index;
};

struct parser *input_parser_init(struct input_parser *parser);
void input_parser_read_byte(struct input_parser *parser, uint8_t byte);
void input_parser_reset(struct input_parser *parser);

#endif /* INPUTPARSER_H_INCLUDED */
